import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
//import java.awt.Color;

/**
 * Write a description of class aaa here.
 * 
 * @author Keenan M. Gebze
 * @version 1.0
 */
public class BadanUlar extends Ular {
        
    private BisaDiikuti bagianUlar;
    private Point posisiAkhir;
    private boolean bisaDiikuti;
    private Arah arahPeledakan;
        
    public BadanUlar(BisaDiikuti bagianLainnya) {
        this.bagianUlar = bagianLainnya;
        GreenfootImage gambar = new GreenfootImage(20,20);
        gambar.setColor(Color.BLACK);
        gambar.fill();
        setImage(gambar);
            
        bisaDiikuti = true;
    }
        
    public void act() {
        posisiAkhir = new Point(getX(), getY());
        if(bagianUlar.bisaDiikuti()){setLocation((int)bagianUlar.posisiAkhir().getX(), (int)bagianUlar.posisiAkhir().getY());}
        if(((Actor)yangDiikuti()).getWorld() == null || !((BisaDiikuti)yangDiikuti()).bisaDiikuti()) {
            meledak();
        }
    }
        
    public BisaDiikuti yangDiikuti() {
        return bagianUlar;
    }

    public Point posisiAkhir() {
        return posisiAkhir;
    }
        
    public boolean bisaDiikuti() {
        return bisaDiikuti;
    }
    
    private void meledak() {
        if(bisaDiikuti) {
            arahPeledakan = Arah.arahAcak();
            bisaDiikuti = false;
        }
        move(arahPeledakan);
    }   
 }